Subject: Re: [PATCH v2] mm: vmscan: do not throttle based on pfmemalloc reserves if node has no reclaimable pages

From: Vlastimil Babka <[email-masked]>
Date: Wed, 06 May 2015 11:28:12 +0200

On 05/06/2015 12:09 AM, Nishanth Aravamudan wrote:
> On 03.04.2015 [10:45:56 -0700], Nishanth Aravamudan wrote:
>>> What I find somewhat worrying though is that we could potentially
>>> break the pfmemalloc_watermark_ok() test in situations where
>>> zone_reclaimable_pages(zone) == 0 is a transient situation (and not
>>> a permanently allocated hugepage). In that case, the throttling is
>>> supposed to help system recover, and we might be breaking that
>>> ability with this patch, no?
>>
>> Well, if it's transient, we'll skip it this time through, and once there
>> are reclaimable pages, we should notice it again.
>>
>> I'm not familiar enough with this logic, so I'll read through the code
>> again soon to see if your concern is valid, as best I can.
>
> In reviewing the code, I think that transiently unreclaimable zones will
> lead to some higher direct reclaim rates and possible contention, but
> shouldn't cause any major harm. The likelihood of that situation, as
> well, in a non-reserved memory setup like the one I described, seems
> exceedingly low.

OK, I guess when a reasonably configured system has nothing to reclaim, 
it's already busted and throttling won't change much.

Consider the patch Acked-by: Vlastimil Babka <[email-masked]>

> Thanks,
> Nish